#include "ural.h"
#include "beama.h"

#define FL_OVWR 0 /*для setenv*/

pthread_t pttick_id; /*Указатель на поток таймера*/

/*Ликвидируем программу в случае привышения лимита времени*/
void * tick_tack (void * empty) {
  sleep(BEAM_LIFE_TIME); /*Задержка на 3 секунды */
  errexit("tick_tack: time out\n");
  return empty;
}

int beama (int sock) {
  /*Запуск контроля продолжительности жизни*/
  pthread_create (&pttick_id, NULL, &tick_tack, NULL); /*Запускается без консоли*/
  /*Сама функция*/
  char buf_temp[BUFSIZ];
  char buf[BUFSIZ]; /*Буфер для запроса из сети*/
  int cc, cc_sum = 0;
  bzero (buf, BUFSIZ);
  bzero (buf_temp, BUFSIZ);
  /*Начальный код чтения запроса, того что хочет получить в ответ*/
  while ((cc = read(sock, buf_temp, sizeof (buf_temp))) != 0) {
    if (cc < 0) {
      fprintf(stderr,"%ld %s", time(NULL), (char *)&buf[0]);
      fflush(stderr);
      errexit("read: error\n");
    }
    cc_sum += cc; /*Чтобы не переполнить буфер*/
    if (cc_sum < BUFSIZ) strcat((char *)&buf[0],(char *)&buf_temp[0]);
    if (!read_stop(buf_temp)) break;
  }
  /*Записываем запрос в лог файл*/
  fprintf(stderr,"%ld %s\n\n\n", time(NULL), (char *)&buf[0]);
  fflush(stderr);
  /*Выделяем имя запрашиваемого объекта*/
  /*Путь к объекту ИСПРАВИТЬ РАЗМЕР*/
  char filepath[PATH_SIZE] = {0};
  get_fs_path ((const char *)&buf[0], (char *)&filepath[0]);
  /*Определяем наличие запрашиваемого объекта и тип папка или файл*/
  switch (file_or_not ((const char *)&filepath[0])) {
    case 2: { /*Папка, имени файла нет*/
      /*запускаем файл index.html*/
      if (filepath[strlen(&filepath[0])-1] != '/')
          strcat((char *)&filepath[0],"/");
      strcat((char *)&filepath[0],"index.html");
      if (file_or_not ((char *)&filepath[0]) == 1) {
        /*Отправляем заголовок html документа*/
        send_header (sock, "html");
        /*Отправляем документ*/
        send_file(sock, (char *)&filepath[0]);
        return 0;
      }
      /*Отрезаем от пути index.html*/
      filepath[strlen(&filepath[0])-10] = 0;
      /*запускаем файл index*/
      strcat((char *)&filepath[0],"index");
      run((char *)&buf[0], (char *)&filepath[0], sock);
      break;
    }
    case 1: { /*Файл, если скрипт функция сама вызовет*/
      if (show_page(sock, (char *)&filepath[0]) == 0) {
        run((char *)&buf[0], (char *)&filepath[0], sock);
      }
      break;
    }
    default: show_error(sock); /*Объект не обнаружен*/
  }
  return 0;
}

/*Отображение страницы по типу расширения*/
int show_page(int sock, char * path) {
  /*Если файл, определяем расширение*/
  int i = strlen(path);
  int j, flag;
  j = flag = 0;
  for (; i > 0; i--) {
    j++; /*Чтобы больше 5 символов не проходил*/
    if (j > 6) break;
    if (path[i] == '.') {
      flag = 1;
      break;
    }
  }
  i++; /*Чтобы перейти за точку*/
  /*Если скрипт, возвращаем 0*/
  if (flag == 0) return 0; /*Файл без расширения*/
  if (strcmp((char *)&path[i],"sh") == 0) return 0;
  if (strcmp((char *)&path[i],"exe") == 0) return 0;
  /*выбираем заголовок и отдаем файл*/
  if (strcmp((char *)&path[i],"html") == 0) {
    send_header (sock, "html");
  } else
  if (strcmp((char *)&path[i],"htm") == 0) {
    send_header (sock, "htm");
  } else
  if (strcmp((char *)&path[i],"svg") == 0) {
    send_header (sock, "svg");
  } else
  if (strcmp((char *)&path[i],"css") == 0) {
    send_header (sock, "css");
  } else
  if (strcmp((char *)&path[i],"jpeg") == 0) {
    send_header (sock, "jpeg");
  } else
  if (strcmp((char *)&path[i],"jpg") == 0) {
    send_header (sock, "jpg");
  } else
  if (strcmp((char *)&path[i],"png") == 0) {
    send_header (sock, "png");
  } else
  if (strcmp((char *)&path[i],"gif") == 0) {
    send_header (sock, "gif");
  } else
  if (strcmp((char *)&path[i],"mp3") == 0) {
    send_header (sock, "mp3");
  } else
  if (strcmp((char *)&path[i],"mp4") == 0) {
    send_header (sock, "mp4");
  } else
  if (strcmp((char *)&path[i],"ogv") == 0) {
    send_header (sock, "ogv");
  } else
  if (strcmp((char *)&path[i],"webm") == 0) {
    send_header (sock, "webm");
  }
  /*Отправляем сам документ*/
  send_file(sock, (char *)&path[0]);
  return 1;
}

/*Функция запуска скриптов*/
void run(const char * query, const char * path, int sock) {
  /*Подготавливаем переменные окружения из запросов. В следующей версии.*/
  /*Отправляем заголовок html документа
  TODO СДЕЛАТЬ ВЫБОР ЗАГОЛОВКА*/
  send_header (sock, "html");
  /*Устанавливаем переменные окружения*/
  char buffer [BUFSIZ] = {0};
  bzero (buffer, BUFSIZ);
  char content_length [100] = {0};
  bzero (content_length, 100);
  /*Если GET*/
  if ((query[0] == 'G') && (query[1] == 'E') && (query[2] == 'T')) {
    /*Устанавливаем переменную REQUEST_METHOD*/
    setenv ("REQUEST_METHOD", "GET", FL_OVWR);
    /*Выделяем GET из запроса.Создаем строку для задания переменной окружения*/
    setenv ("QUERY_STRING", get_get (query, (char *)&buffer[0]), FL_OVWR);
  }
  else { /*Если POST*/
    if ((query[0] == 'P') && (query[1] == 'O') && (query[2] == 'S') && (query[3] == 'T')) {
      /*Устанавливаем переменную REQUEST_METHOD*/
      setenv ("REQUEST_METHOD", "POST", FL_OVWR);
      get_post (query, (char *)&buffer[0], (char *)&content_length[0]);
      setenv ("CONTENT_LENGTH", (char *)&content_length[0], FL_OVWR);
    }
    else {
      /*Отправляем документ Путь до страницы ошибки 404 //В КОНФИГУРАТОР*/
      send_file(sock, FILE404ERROR);
      return;
    }
  }
  /*Запускаем скрипт с перехватом вывода и отправкой его в сеть.*/
  int fds_STDIN[2];
  int fds_STDOUT[2];
  pid_t pid;
  /*Создание канала. Дескрипторы обоих концов канала помещаем в массив FDS*/
  ioresult = pipe(fds_STDIN);
  ioresult = pipe(fds_STDOUT);
  /*Создание дочернего процесса*/
  pid = fork();
  if (pid == (pid_t)0) {
    /*Закрываем копию входного конца канала*/
    close (fds_STDOUT[0]);
    /*Это дочерний процесс. Закрываем копию входного конца канала*/
    close (fds_STDIN[1]);
    /*Соединяем выходной конец канала со стандартным входным потоком*/
    dup2 (fds_STDIN[0], STDIN_FILENO);
    /*Копировать указатель на файл в указатель на стандартный поток вывода*/
    dup2 (fds_STDOUT[1], STDOUT_FILENO);
    /*здесь вывода не будет, поток перенаправлен
    замещаем дочерний процесс программой*/
    execlp (path, path, (char *)0);
  }
  else {
    /*Это родительский процесс*/
    close (fds_STDIN[0]);
    close(fds_STDOUT[1]);
    size_t read_size = 0;
    /*Если GET*/
    if ((query[0] == 'G') && (query[1] == 'E') && (query[2] == 'T')) {
      /*Закрываем копию выходного конца канала*/
      close(fds_STDIN[1]);
      /*Читаем из pipe до конца и отправляем в сокет.*/
      FILE * streamOUT;
      streamOUT = fdopen (fds_STDOUT[0],"rb");
      while ((read_size = fread((char *)&buffer[0], sizeof(char), BUFSIZ-1, streamOUT)) > 0) {
        ioresult = write(sock,(void *)&buffer[0],read_size);
      }
      fflush(streamOUT);
      close (fds_STDOUT[0]);
    }
    else { /*Если POST*/
      if ((query[0] == 'P') && (query[1] == 'O') && (query[2] == 'S') && (query[3] == 'T')) {
        FILE * streamIN;
        /*Приводим дескриптор входного конца канала к типу FILE* и записываем данные в канал*/
        streamIN = fdopen (fds_STDIN[1],"wb");
        /*Отправляем в поток ввода скрипта*/
        fwrite((char *)&buffer[0], sizeof(char), atoi ((char *)&content_length[0]), streamIN);
        fflush(streamIN);
        close (fds_STDIN[1]);
        /*Читаем из pipe до конца.*/
        FILE * streamOUT;
        streamOUT = fdopen (fds_STDOUT[0],"rb");
        while ((read_size = fread((char *)&buffer[0], sizeof(char), BUFSIZ-1, streamOUT)) > 0) {
        ioresult = write(sock,(void *)&buffer[0],read_size);
        }
        fflush(streamOUT);
        fclose(streamOUT);
        close (fds_STDOUT[0]);
        /*Дожидаемся завершения дочернего процесса*/
        waitpid (pid, NULL, 0);
      }
      else {
        /*Отправляем документ Путь до страницы ошибки 404*/
        send_file(sock, FILE404ERROR);
      }
    }
  }
}

/*Возвращает длину контента из POST запроса */
char * get_post (const char * query, char * buffer, char * content_length) {
  /*Находим и передаем значение в content_length: */
  char * strptr = strstr(query, "Content-Length:");
  /*Выделяем длину запроса*/
  int count_strptr;
  int count = 0; /*Значение 25 для строки Content-Length:*/
  for (count_strptr = 16; count_strptr < 25; count_strptr++) {
    /*Учитываем прерывающие символы  */
    if ((strptr[count_strptr] == '\n') || (strptr[count_strptr] == 0) ||
        (strptr[count_strptr] == ' ')) break;
    content_length[count] = strptr[count_strptr];
    count++;
  }
  /*завершаем конец строки нулем*/
  content_length[count] = 0;
  /*Откручиваем до начала данных POST*/
  count_strptr = 0;
  strptr = query;
  while(strptr[count_strptr] != 0) {
    /*Последовательность: 10 13 10*/
    if ((strptr[count_strptr] == 10) && (strptr[count_strptr+1] == 13) && (strptr[count_strptr+2] == 10)) {
      count_strptr++; /*Чтобы перескачить через символ новой строки*/
      break;
    }
    count_strptr++;
  }
  /*Читаем пост в нужном кол-ве*/
  count = 0;
  int content_length_int = atoi(content_length);
  while (strptr[count_strptr] != 0) {
    buffer[count] = strptr[count_strptr];
    if (count > content_length_int) break;
    count++;
    count_strptr++;
  }
  /*завершаем концы строк нулями*/
  buffer[count] = 0;
  return content_length;
}

/*Возвращает get из запроса*/
char * get_get (const char * query, char * buffer) {
  /*Пропускаем GET / */
  int count_query = 4;
  int count_buffer = 0;
  int flag = 0;
  /*От ? до первого пробела*/
  while (1) {
    if (query[count_query] == ' ') break;
    if (query[count_query] == '\n') break;
    if (query[count_query] == 0) break;
    if (query[count_query] == '?') flag = 1;
    if (flag == 1) {
      buffer[count_buffer] = query[count_query];
      count_buffer++;
    }
    count_query++;
  }
  return buffer;
}

/*Отображение страницы ошибки*/
void show_error (int fd) {
  /*Отправляем заголовок html документа*/
  send_header (fd, "html");
  send_file(fd, FILE404ERROR);
}

/*Отправляем файл в сокет*/
void send_file(int sock, char * full_path) {
  /*Определяем размер файла с ошибкой для отправки*/
  struct stat statbuf;
  /*Информация о файле*/
  memset((void*)&statbuf,0,sizeof(statbuf));
  stat(full_path, &statbuf);
  /*Формируем и отправляем документ*/
  char buffer[statbuf.st_size];
  bzero(buffer,statbuf.st_size);
  /*Прочитать и отправить файл*/
  FILE * file;
  file = fopen (full_path, "rb");
  if (file==NULL) return;
  /*TODO: Исправить! Большой файл может обвалить стек*/
  ioresult = fread (buffer,1,statbuf.st_size,file);
  ioresult = write(sock,buffer,statbuf.st_size); /*Читаем и отправляем в двоичном виде*/
  fclose (file);
}

/*0 - файл не обнаружен, 1 - файл, 2 - папка*/
int file_or_not (const char * path) {
  struct stat statbuf;
  /*Информация о файле*/
  memset((void*)&statbuf,0,sizeof(statbuf));
  stat(path, &statbuf);
  if (statbuf.st_mode == 0) return 0;
  /*S_IFDIR = 16384 проверяем 15-й бит, если есть, папка*/
  if ((statbuf.st_mode & 32767) >> 14) return 2;
  return 1;
}

/*Получение имени запрашиваемого объекта в файловой системе*/
char * get_fs_path(const char * query, char * fs_path) {
  char * html_folder = "../usr/html/"; /*При загрузки пути проверять последний символ*/
  char * cgi_bin_folder = "../usr/cgi-bin/"; /*чтобы небыло наклонной*/
  bzero(fs_path, PATH_SIZE);
  char * temp_string = NULL;
  if ((temp_string = strstr(query, "GET")) != NULL) temp_string = temp_string + 4; /*Чтобы начать после GET и пробела*/
  else if ((temp_string = strstr(query, "POST")) != NULL) temp_string = temp_string + 5; /*Чтобы начать после GET и пробела*/
  else return NULL;
  /*Если первая вложенная папка cgi-bin, добавляем путь к cgi-bin*/
  int sts = strlen(temp_string);
  if (sts > 7) {
    if ((temp_string[1]=='c') && (temp_string[2]=='g') && (temp_string[3]=='i') &&
        (temp_string[4]=='-') && (temp_string[5]=='b')  && (temp_string[6]=='i') &&
        (temp_string[7]=='n')) {
       /*cgi-bin есть, добавляем*/
       strcpy(fs_path, cgi_bin_folder);
       /*Отрезаем последнюю папку cgi-bin*/
       if (fs_path[strlen(fs_path)-1] == '/') fs_path[strlen(fs_path)-8] = 0;
       else  fs_path[strlen(fs_path)-7] = 0;
    }
    /*иначе добавляем путь до html папки*/
    else strcpy(fs_path, html_folder);
  }
  int i = 0, j = strlen(fs_path);
  if (fs_path[j-1] == '/') j--; /*т.к. с / всегда начинается get*/
  while ((temp_string[i] != ' ') && (temp_string[i] != '?') &&
         (temp_string[i] != 0)) {
    fs_path[j] = temp_string[i];
    i++;
    j++;
  }
  return fs_path;
}

/*Получение строки с текущим GMT временем*/
char * get_current_gmt_string (char * st) {
  time_t current_time = time(NULL);
  struct tm * timeinfo = NULL;
  time (&current_time);
  timeinfo = gmtime (&current_time);
  static const char wday_name[][4] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
  static const char mon_name[][4] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
  sprintf(st, "%.3s, %2d %.3s %d %.2d:%.2d:%.2d GMT\n",
    wday_name[timeinfo->tm_wday], timeinfo->tm_mday,
    mon_name[timeinfo->tm_mon], 1900 + timeinfo->tm_year,
    timeinfo->tm_hour, timeinfo->tm_min, timeinfo->tm_sec);
  return st;
}

/*Проверка условия окончания получения данных из сети*/
int read_stop(const char * query) {
  if ((strstr(query, "Connection:") != 0) && (strstr(query, "Accept-Language:") != 0) &&
      (strstr(query, "HTTP") != 0) && (strstr(query, "Host:") != 0) &&
      ((strstr(query, "GET") != 0) ||
      ((strstr(query, "POST") != 0) && ((strstr(query, "Content-Length:") != 0))))) return 0;
  return 1;
}

/*Выводим заголовок http 1.1*/
void send_header (int sock, char * type) {
  char buffer[100];
  bzero(buffer,100);
/*  strcpy(buffer,"HTTP/1.1 200 OK\n"); */
  strcpy(buffer,"HTTP/1.1 200 OK");
  ioresult = write(sock,buffer,strlen(buffer));
  bzero(buffer,100);
  /*TODO: Возможны преобразования в двухбайтовые символы в консоли.
    Разобраться с кодировками консоли.*/
  char st[54] = {0};
  strcpy(buffer,"Date: ");
  strcat(buffer,get_current_gmt_string ((char *)&st[0]));
  ioresult = write(sock,buffer,strlen(buffer));
  bzero(buffer,100);
  strcpy(buffer,"Server: Ural\n");
  ioresult = write(sock,buffer,strlen(buffer));
  bzero(buffer,100);
  /*Выбираем тип заголовка*/
  strcpy(buffer,"Content-Type: ");
  if (strcmp(type,"html") == 0) {
    strcat(buffer,"text/html");
  } else
  if (strcmp(type,"htm") == 0) {
    strcat(buffer,"text/html");
  } else
  if (strcmp(type,"css") == 0) {
    strcat(buffer,"text/css");
  } else
  if (strcmp(type,"svg") == 0) {
    strcat(buffer,"image/svg+xml");
  } else
  if (strcmp(type,"gif") == 0) {
    strcat(buffer,"image/gif");
  } else
  if (strcmp(type,"png") == 0) {
    strcat(buffer,"image/png");
  } else
  if (strcmp(type,"jpeg") == 0) {
    strcat(buffer,"image/jpeg");
  } else
  if (strcmp(type,"jpg") == 0) {
    strcat(buffer,"image/jpeg");
  } else
  if (strcmp(type,"mp3") == 0) {
    strcat(buffer,"audio/mpeg");
  } else
  if (strcmp(type,"mp4") == 0) {
    strcat(buffer,"video/mp4");
  } else
  if (strcmp(type,"ogv") == 0) {
    strcat(buffer,"video/ogg");
  } else
  if (strcmp(type,"webm") == 0) {
    strcat(buffer,"video/webm");
  } else
  if (strcmp(type,"webp") == 0) {
    strcat(buffer,"image/webp");
  }
  if (strcmp(type,"pdf") == 0) {
    strcat(buffer,"application/pdf");
  }
  if (strcmp(type,"zip") == 0) {
    strcat(buffer,"application/x-zip-compressed");
  }
  if (strcmp(type,"gz") == 0) {
    strcat(buffer,"application/x-gzip");
  }
  strcat(buffer,"\n");
  ioresult = write(sock,buffer,strlen(buffer));
  bzero(buffer,100);
  strcpy(buffer,"Connection: close\n\n");
  ioresult = write(sock,buffer,strlen(buffer));
  bzero(buffer,100);
}
