#ifndef	_URAL_H

#include <sys/signal.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/errno.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>
#include <stdio.h>
#include <memory.h>
#include <time.h>
#include <unistd.h>

/*Константы загружать из файла конфигурации*/
#define	QLEN 32 /*Максимальная длинна очереди запросов*/
#define LOGFILE "../log/access.log"
#define PORT "8090"
#define TRANSPORT "tcp"
#define TRANSPORT_UDP "udp"
#define BEAM_LIFE_TIME 30 /*в секундах время жизни потока (было 3 упал POST)*/
#define	BUFSIZE 4096  /*Размер буфера НАДО В КОНФИГУРАЦИЮ*/
#define PATH_SIZE 777 /*Размер пути к файлу НАДО В КОНФИГУРАЦИЮ*/
#define FILE404ERROR "../usr/html_service/error404.html"

extern int errno;
int msock; /*ведущий сокет сервера*/
int ssock; /*ведомый сокет сервера*/

/*Пишим ошибку в поток ошибок*/
int errexit (const char *format);
/*чистка зомби процессов*/
void reaper (int);
int load_config (void);
/*passivesock - allocate & bind серверный сокет используя TCP или UDP*/
/*Аргументы: service   - сервис ассоциированный и портом
transport - транспортный протокол, использовать ("tcp" или "udp")
qlen - maximum server request queue length*/
int passivesock(const char *service, const char *transport, int qlen);

#endif
